﻿Imports System.Web.Mvc
Imports System.Web.WebPages
Imports PhotoGallery.Repositories
Imports WebMatrix.WebData
Imports System.Collections

Namespace after.Controllers
    Public Class AccountController
        Inherits Controller
        Public Function Login() As ActionResult
            ViewBag.Title = "Login"
            Return View()
        End Function

        <HttpPost>
        Public Function Login(ByVal email As String, ByVal password As String, ByVal rememberMe? As Boolean, ByVal returnUrl As String) As ActionResult
            If email.IsEmpty() Then
                ModelState.AddModelError("email", "You must specify an email address.")
            End If
            If password.IsEmpty() Then
                ModelState.AddModelError("password", "You must specify a password.")
            End If

            If Not ModelState.IsValid Then
                Return View()
            End If

            If WebSecurity.Login(email, password,If(rememberMe.HasValue, rememberMe.Value, False)) Then
                If Not String.IsNullOrEmpty(returnUrl) Then
                    Return Redirect(returnUrl)
                End If

                Return RedirectToAction("Default", "Gallery")
            End If

            ModelState.AddModelError("_FORM", "The email or password provided is incorrect")
            Return View()
        End Function

        Public Function Register() As ActionResult
            ViewBag.Title = "Register"
            Return View()
        End Function

        <HttpPost>
        Public Function Register(ByVal email As String, ByVal password As String, ByVal confirmPassword As String) As ActionResult
            If email.IsEmpty() Then
                ModelState.AddModelError("email", "You must specify an email address.")
            End If
            If password.IsEmpty() Then
                ModelState.AddModelError("password", "You must specify a password.")
            End If
            If confirmPassword.IsEmpty() Then
                ModelState.AddModelError("confirmPassword", "You must specify a confirm password.")
            End If
            If password <> confirmPassword Then
                ModelState.AddModelError("_Form", "The new password and confirmation password do not match.")
            End If

            If Not ModelState.IsValid Then
                Return View()
            End If

            Dim db = New AccountRepository
            Dim user = db.GetAccountEmail(email)

            If user Is Nothing Then
                db.CreateAccount(email)

                Try
                    WebSecurity.CreateAccount(email, password)
                    WebSecurity.Login(email, password)

                    Return RedirectToAction("Default", "Gallery")
                Catch e As System.Web.Security.MembershipCreateUserException
                    ModelState.AddModelError("_FORM", e.ToString())
                End Try
            Else
                ModelState.AddModelError("_FORM", "Email address is already in use.")
            End If

            Return View()
        End Function

        Public Function Logout() As ActionResult
            WebSecurity.Logout()
            Return RedirectToAction("Default", "Gallery")
        End Function
    End Class
End Namespace
