﻿Imports System.Web.Mvc
Imports PhotoGallery.Repositories
Imports System.Dynamic
Imports System.Web.Helpers

Namespace after.Controllers
    Public Class TagController
        Inherits Controller
        Public Function [Default]() As ActionResult
            ViewBag.Title = "View All Tags"

            Dim repository = New TagRepository()
            Dim tagsList = repository.GetTagList()

            Return View(tagsList)
        End Function

        <OutputCache(Duration:=60)>
        Public Function Thumbnail(ByVal id As String) As ActionResult
            Dim repository = New TagRepository()
            Dim tag = repository.GetTag(id)
            Dim photoList = repository.GetPhotoList(id)

            If tag IsNot Nothing AndAlso photoList.Count > 0 Then
                Using generator As New MultiThumbnailGenerator()
                    For Each photo In photoList
                        Using imageStream = New System.IO.MemoryStream(CType(photo.FileContents, Byte()))
                            Using image = System.Drawing.Image.FromStream(imageStream)
                                generator.AddImage(image)
                            End Using
                        End Using
                    Next photo

                    Using outStream = New System.IO.MemoryStream()
                        generator.WritePngToStream(outStream)
                        Dim image = New WebImage(outStream)
                        image.Write()
                    End Using
                End Using

                Return Nothing
            End If

            Return Redirect("~/Content/Images/gallery-empty.png")
        End Function

        Public Function _View(ByVal id As String) As ActionResult
            ViewBag.Title = "View Tag - " & id

            Dim model As Object = New ExpandoObject()
            model.TagName = id

            Dim repository = New TagRepository()
            model.Photos = repository.GetPhotos(id)
            model.SimilarTags = repository.GetSimilarTags(id)

            Return View(model)
        End Function
    End Class
End Namespace
