﻿Imports System.Web.Mvc
Imports System.Dynamic
Imports System.Web.WebPages
Imports PhotoGallery.Repositories
Imports WebMatrix.WebData

Namespace after.Controllers
    <Authorize()>
    Public Class UserController
        Inherits Controller
        Public Function [Default]() As ActionResult
            Dim userRepository = New UserRepository()
            Dim user = userRepository.GetUserById(WebSecurity.CurrentUserId)

            ViewBag.Title = "Edit Profile - " & user.DisplayName.ToString

            Return View(user)
        End Function

        <HttpPost()>
        Public Function [Default](ByVal displayName As String, ByVal bio As String) As ActionResult
            If Not displayName Then
                ModelState.AddModelError("displayName", "You must specify a display name.")
            End If

            If ModelState.IsValid Then
                Dim userRepository = New UserRepository()
                userRepository.UpdateUserProfile(displayName, bio, WebSecurity.CurrentUserId)

                Return RedirectToAction("View", New With {Key .id = WebSecurity.CurrentUserId})
            End If

            Return View()
        End Function

        Public Function _View(ByVal id As Integer) As ActionResult
            Dim userModel As Object = New ExpandoObject()

            Dim userRepository = New UserRepository()
            Dim user = userRepository.GetUserById(id)

            If user Is Nothing Then
                Return HttpNotFound()
            End If

            ViewBag.Title = "User - " & user.DisplayName.ToString

            Dim photo = userRepository.GetPhotos(id)

            userModel.User = user
            userModel.Photos = photo

            Return View(userModel)
        End Function
    End Class
End Namespace
