﻿Imports WebMatrix.Data

Namespace PhotoGallery.Repositories
    Public Class TagRepository
        Private ReadOnly _database As Database

        Public Sub New()
            _database = Database.Open("PhotoGallery")
        End Sub

        Public Function GetTagList() As IList(Of Object)
            Return _database.Query("SELECT Tags_TagName AS TagName, COUNT(*) AS TagCount " & ControlChars.CrLf &
                                   "FROM Photos_Tags " & ControlChars.CrLf &
                                   "GROUP BY Tags_TagName " & ControlChars.CrLf &
                                   "ORDER BY Tags_TagName").ToList()
        End Function

        Public Function GetPhotos(ByVal tagName As String) As IList(Of Object)
            Return _database.Query("SELECT Photos.Id, Photos.FileTitle " & ControlChars.CrLf &
                                   "FROM Photos, Photos_Tags " & ControlChars.CrLf &
                                   "WHERE Photos.Id = Photos_Tags.Photos_Id AND Photos_Tags.Tags_TagName = @0", tagName).ToList()
        End Function


        Public Function GetSimilarTags(ByVal tagName As String) As IList(Of Object)
            Return _database.Query("SELECT Tags_TagName AS TagName, COUNT(*) AS Count " & ControlChars.CrLf &
                                   "FROM Photos_Tags WHERE Photos_Id IN (SELECT Photos_Id FROM Photos_Tags WHERE Tags_TagName = @0) AND Tags_TagName != @0" & ControlChars.CrLf &
                                   "GROUP BY Tags_TagName " & ControlChars.CrLf &
                                   "ORDER BY Count DESC", tagName).ToList()
        End Function

        Public Function GetTag(ByVal tagName As String) As Object
            Return _database.Query("SELECT TagName FROM Tags WHERE TagName = @0", tagName)
        End Function

        Public Function GetPhotoList(ByVal tagName As String) As IList(Of Object)

            Return _database.Query("SELECT TOP(3) Photos.FileContents " & ControlChars.CrLf &
                                   "FROM Photos, Photos_Tags " & ControlChars.CrLf &
                                   "WHERE Photos.Id = Photos_Tags.Photos_Id AND Photos_Tags.Tags_TagName = @0", tagName).ToList()
        End Function

        Public Function GetTagListByPhoto(ByVal id As Integer) As IList(Of Object)
            Return _database.Query("SELECT Tags_TagName FROM Photos_Tags WHERE Photos_Id = @0 ORDER BY Tags_TagName", id).ToList()
        End Function

        Public Function GetTagCount(ByVal tag As String) As Integer
            Return CInt(Fix(_database.QueryValue("SELECT COUNT(*) FROM Tags WHERE TagName = @0", tag)))
        End Function

        Public Sub InsertTag(ByVal tag As String)
            _database.Execute("INSERT INTO Tags (TagName) VALUES (@0)", tag)
        End Sub
    End Class
End Namespace
