﻿Imports WebMatrix.Data

Namespace PhotoGallery.Repositories
    Public Class UserRepository
        Private ReadOnly _database As Database

        Public Sub New()
            _database = Database.Open("PhotoGallery")
        End Sub

        Public Function GetUserById(ByVal id As Integer) As Object
            Return _database.QuerySingle("SELECT UserId, DisplayName, Bio FROM UserProfiles WHERE UserId = @0", id)
        End Function

        Public Function GetPhotos(ByVal id As Integer) As Object
            Return _database.Query("SELECT Id, FileTitle FROM Photos WHERE UserId = @0 ORDER BY FileTitle", id).ToList()
        End Function

        Public Function UpdateUserProfile(ByVal displayName As String, ByVal bio As String, ByVal userId As Integer) As Integer
            Return _database.Execute("UPDATE UserProfiles SET DisplayName = @0, Bio = @1 WHERE UserId = @2", displayName, bio, userId)
        End Function
    End Class
End Namespace