﻿@Code
    Page.Title = "Login"

	If IsPost Then
		Dim email = Request("email")
		If email.IsEmpty() Then ModelState.AddError("email", "You must specify an email address.")

		Dim password = Request("password")
		If password.IsEmpty() Then ModelState.AddError("password", "You must specify a password.")

		If ModelState.IsValid Then
			Dim rememberMe = Request("rememberMe").AsBool()
			If WebSecurity.Login(email, password, rememberMe) Then
                Dim returnUrl = Request("returnUrl")
				If Not returnUrl.IsEmpty() Then
					Context.RedirectLocal(returnUrl)
				Else
					Response.Redirect("~/")
				End If
			Else
				ModelState.AddFormError("The email or password provided is incorrect.")
			End If
		End If
	End If
End Code
   
<h1>Login</h1>

<p>
    Please enter your email and password below. If you don't have an account,
    please <a href="@Href("Register")">Register</a>.
</p>

@Html.ValidationSummary(excludeFieldErrors:=True)

<form method="post" action="">
    <fieldset class="no-legend">
        <legend>Login</legend>
        <ol>
            <li class="email">
                <label for="email">Email</label>
                <input type="text" id="email" name="email" title="Email Address" placeholder="Email address" class="@PhotoGallery.GetValidationClass("email")" />
                @Html.ValidationMessage("email")
            </li>
            <li class="Password">
                <label for="password">Password</label>
                <input type="password" id="password" name="password" title="Password" class="@PhotoGallery.GetValidationClass("password")" />
                @Html.ValidationMessage("password")
            </li>
            <li class="remember-me">
                <label class="checkbox" for="rememberMe">Remember Me?</label>
                <input type="checkbox" id="rememberMe" name="rememberMe" value="true" title="Remember Me" />
            </li>
        </ol>
        <p class="form-actions">
            <input type="submit" value="Login" title="Login" />
        </p>
    </fieldset>
</form>