﻿@Code
    Page.Title = "Register"

	If IsPost Then
		'If Not ReCaptcha.Validate("PRIVATE_KEY") Then
		'    ModelState.AddFormError("Captcha response was not correct.")
		'End If

		Dim email = Request("email")
		If email.IsEmpty() Then ModelState.AddError("email", "You must specify an email address.")

		Dim password = Request("password")
		Dim confirmPassword = Request("confirmPassword")

		If password.IsEmpty() Then ModelState.AddError("password", "You must specify a password.")

		If confirmPassword.IsEmpty() Then ModelState.AddError("confirmPassword", "You must specify a confirm password.")

		If password <> confirmPassword Then ModelState.AddFormError("The new password and confirmation password do not match.")

		If ModelState.IsValid Then
			' Create the user profile
			Dim db = Database.Open("PhotoGallery")

			' Check if user already exists
			Dim user = db.QuerySingle("SELECT Email FROM UserProfiles WHERE LOWER(Email) = LOWER(@0)", email)
			If user Is Nothing Then
				' Insert email into the profile table
				db.Execute("INSERT INTO UserProfiles (Email, DisplayName, Bio) VALUES (@0, @1, @2)", email, email, "")

				' Create and associate a new entry in the membership database.
				' If successful, continue processing the request
				Try
					WebSecurity.CreateAccount(email, password)
					WebSecurity.Login(email, password)
					Response.Redirect("~/")
				Catch e As System.Web.Security.MembershipCreateUserException
					ModelState.AddFormError(e.ToString())
				End Try
			 Else
				' User already exists
				ModelState.AddFormError("Email address is already in use.")
			 End If
		End If
	End If
End Code

<h1>Account Creation</h1>
<p>
    Use the form below to create a new account. 
</p>

@Html.ValidationSummary(excludeFieldErrors:=True)

<form method="post" action="">
    <fieldset class="no-legend">
        <legend>Account Creation</legend>
                <ol>
            <li class="email">
                <label for="email">Email:</label>
                <input type="text" id="email" name="email" title="Email address" placeholder="Email address" class="@PhotoGallery.GetValidationClass("email")" />
                @Html.ValidationMessage("email")
            </li>
            <li class="password">
                <label for="password">Password:</label>
                <input type="password" id="password" name="password" title="Password" class="@PhotoGallery.GetValidationClass("password")" />
                @Html.ValidationMessage("password")
            </li>
            <li class="confirm-password">
                <label for="confirmPassword">Confirm Password:</label>
                <input type="password" id="confirmPassword" name="confirmPassword" title="Confirm password" class="@PhotoGallery.GetValidationClass("confirmPassword")" />
                @Html.ValidationMessage("confirmPassword")
            </li>
            <li class="recaptcha">
                <div class="message info">
                    <p>To enable CAPTCHA verification, uncomment ReCaptcha.GetHtml and replace 'PUBLIC_KEY'
                    with your public key.  At the top of this page, uncomment ReCaptcha.Validate and
                    replace 'PRIVATE_KEY' with your private key.</p>
                    <p>Register for reCAPTCHA keys at <a href="http://recaptcha.net">reCAPTCHA.net</a>.</p>
                </div>
                @*@ReCaptcha.GetHtml("PUBLIC_KEY", theme: "white")*@
            </li>
        </ol>
        <p class="form-actions">
            <input type="submit" value="Register" title="Register" />
        </p>
    </fieldset>
</form>