﻿@Code
    Page.Title = "Photo Gallery"
	Dim db = Database.Open("PhotoGallery")
	Dim galleries = db.Query("SELECT Galleries.Id, Galleries.Name, COUNT(Photos.Id) AS PhotoCount "&
        "FROM Galleries LEFT OUTER JOIN Photos ON Galleries.Id = Photos.GalleryId "&
        "GROUP BY Galleries.Id, Galleries.Name").ToList()   
End Code
<h1>Galleries</h1>
@If galleries.Count = 1 Then
    @<p>There is one gallery.</p>
 Else 
    @<p>There are @galleries.Count galleries.</p>
 End If

<ul class="thumbnails gallery">
    @For Each gallery In galleries 
        @<li class="gallery">
           <a href="@Href("~/Gallery/View", gallery.Id)">
               <img alt="Images from @gallery.Name" src="@Href("~/Gallery/Thumbnail", gallery.Id)" class="thumbnail-no-border" />
               <span class="below-image">@gallery.Name</span>
               <span class="image-overlay">@gallery.PhotoCount photo(s)</span>
           </a>
        </li>
     Next gallery
</ul>
<p class="actions">
@If Websecurity.IsAuthenticated Then
    @<a href="@Href("~/Gallery/New")">Create a New Gallery</a>
End If
</p>