﻿@Code
WebSecurity.RequireAuthenticatedUser()

	Page.Title = "New Gallery"

	If IsPost Then
		Dim galleryName = Request("Name")
		If galleryName.IsEmpty() Then ModelState.AddError("Name", "You must specify a gallery name.")
		If ModelState.IsValid Then
			Dim db = Database.Open("PhotoGallery")
			Dim nameExists = db.QueryValue("SELECT COUNT(*) FROM Galleries WHERE LOWER(Name) = LOWER(@0)", galleryName) > 0
			If nameExists Then
				ModelState.AddError("Name", "A gallery with the supplied name already exists.")
			Else
				'Create Gallery
				db.Execute("INSERT INTO Galleries (Name) VALUES (@0)", galleryName)
				' And redirect
				Response.Redirect(Href("View", db.GetLastInsertId()))
			End If
		End If
	End If
End Code
<h1>New Gallery</h1>
<form method="post" action="">
    <fieldset>
        <legend>New Gallery</legend>
        <ol>
            <li>
                <label for="name">Name</label>
                <input type="text" id="name" name="name" title="Gallery name" placeholder="Gallery name" class="@PhotoGallery.GetValidationClass("name")" />
                @Html.ValidationMessage("Name")
            </li>
        </ol>
        <p class="form-actions">
            <input type="submit" value="Create" title="Create gallery" />
            <a href="@Href("~/Gallery")" title="Return to galleries">Cancel</a>
        </p>
    </fieldset>
</form>