﻿@Code
   ' Cache the image for a minute
	Response.OutputCache(60)

	Dim galleryId = UrlData(0).AsInt()

	Dim db = Database.Open("PhotoGallery")

	Dim gallery = db.QuerySingle("SELECT * FROM Galleries WHERE Id = @0", galleryId)
	If gallery Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	Dim photos = db.Query("SELECT TOP(3) FileContents, UploadDate FROM Photos WHERE GalleryId = @0 ORDER BY UploadDate DESC", galleryId)
	If photos.Count() = 0 Then
		Response.Redirect("~/Images/gallery-empty.png")
		Return
	End If

	Using generator = New MultiThumbnailGenerator
		For Each photo In photos
			Using imageStream = New System.IO.MemoryStream(CType(photo.FileContents,Byte()))
				Using image = System.Drawing.Image.FromStream(imageStream)
					generator.AddImage(image)
				End Using
			End Using
		Next photo
		Using outStream = New System.IO.MemoryStream
			generator.WritePngToStream(outStream)
			Dim image = New WebImage(outStream)
			image.Write()
		End Using
	End Using
End Code