﻿@Code
    WebSecurity.RequireAuthenticatedUser()

	Dim galleryId = UrlData(0).AsInt()

	Dim db = Database.Open("PhotoGallery")

	Dim gallery = db.QuerySingle("SELECT * FROM Galleries WHERE Id = @0", galleryId)
	If gallery Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	Page.Title = "Upload Photo to Gallery - " & gallery.Name
	If IsPost Then
		Dim numFiles = Request.Files.Count
        For i = 0 To numFiles - 1
            Dim file = Request.Files(i)
            If file.ContentLength > 0 Then
                Dim fileUpload = New WebImage(file.InputStream)
                Dim fileTitle = Path.GetFileNameWithoutExtension(file.FileName).Trim()
                If fileTitle.IsEmpty() Then fileTitle = "Untitled"
                Dim fileExtension = Path.GetExtension(file.FileName).Trim()
                Dim fileBytes = fileUpload.GetBytes()
                db.Execute("INSERT INTO Photos " &
                           "(GalleryId, UserId, Description, FileTitle, FileExtension, ContentType, FileSize, UploadDate, FileContents) VALUES " &
                           "(@0, @1, @2, @3, @4, @5, @6, @7, @8)",
                           galleryId,
                           WebSecurity.CurrentUserId,
                           "",
                           fileTitle,
                           fileExtension,
                           fileUpload.ImageFormat,
                           fileBytes.Length,
                           Date.Now,
                           fileBytes)
            End If
        Next i
		Response.Redirect(Href("~/Photo/View", db.GetLastInsertId()))
	End If
End Code

<h1>Upload Photo</h1>

<p>
    The photo you upload will be placed in the
    <a class="italic" href="@Href("View", galleryId)">@gallery.Name</a> gallery.
</p>

@FileUpload.GetHtml()


<div class="message info">
    The default file size is limited to 4MB. To change this you will need to update the 'HttpRuntimeSection/MaxRequestLength' section in web.config. 
</div>