﻿@Code
   Dim galleryId = UrlData(0).AsInt()

	Dim db = Database.Open("PhotoGallery")

	Dim gallery = db.QuerySingle("SELECT * FROM Galleries WHERE Id = @0", galleryId)
	If gallery Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	' Found a match - so show all its photos
	Dim photos = db.Query("SELECT Id, FileTitle FROM Photos WHERE GalleryId = @0", galleryId).ToList()

	Page.Title = "Gallery - " & gallery.Name
End Code
	
<h1>@gallery.Name</h1>

@If photos.Count = 1 Then 
    @<p>This gallery contains one photo.</p>
Else
    @<p>This gallery contains @photos.Count photos.</p>
End If

<ul class="thumbnails">
    @For Each photo In photos 
        @<li>
            <a href="@Href("~/Photo/View", photo.Id)">
                <img alt="thumbnail of @Path.GetFileNameWithoutExtension(photo.FileTitle)" src="@Href("~/Photo/Thumbnail", photo.Id)" class="thumbnail-border" />
                <span class="image-overlay">@Path.GetFileNameWithoutExtension(photo.FileTitle)</span>
            </a>
        </li>
     Next photo
</ul>

@If WebSecurity.IsAuthenticated Then
    @<p class="actions">
        <a href="@Href("~/Gallery/Upload", galleryId)">Upload a Photo</a>
    </p>
End If