﻿@Code
    Dim photoId = UrlData(0).AsInt()

	Dim db = Database.Open("PhotoGallery")

	Dim photo = db.QuerySingle("SELECT * FROM Photos WHERE Id = @0", photoId)
	If photo Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	WebSecurity.RequireUser(photo.UserId)

	Page.Title = "Edit Photo - " & photo.FileTitle

	If IsPost Then
		Dim fileTitle = Request("FileTitle")
		If fileTitle.IsEmpty() Then ModelState.AddError("FileTitle", "You must specify a name")
		Dim description = Request("Description")
		If description.IsEmpty() Then ModelState.AddError("Description", "You must specify a description")
		If ModelState.IsValid Then
			db.Execute("UPDATE Photos SET FileTitle = @0, Description= @1 WHERE Id = @2", fileTitle, description, photoId)
			Response.Redirect(Href("View", photo.Id))
		End If
	End If
End Code

<div class="sidebar">
    <h1>Edit Photo</h1>
    <form method="post" action="">
        <fieldset class="no-legend">
            <legend>Edit Photo</legend>
            <ol>
                <li>
                    <label for="fileTitle">Name:</label>
                    <input type="text" id="fileTitle" name="fileTitle" title="Photo name" value="@photo.FileTitle" placeholder="Photo Name" class="@PhotoGallery.GetValidationClass("fileTitle")" />
                    @Html.ValidationMessage("FileTitle")
                </li>
                <li>
                    <label for="description">Description:</label>
                    <textarea id="description" name="description" title="Photo description" rows="4" cols="30" placeholder="Photo description" class="@PhotoGallery.GetValidationClass("description")">@photo.Description</textarea>
                    @Html.ValidationMessage("Description")
                </li>
            </ol>
            <p class="form-actions">
                <input type="submit" value="Save Changes" title="Save changes" />
                <a href="@Href("~/Photo/View", photoId)" title="Cancel changes">Cancel</a>
            </p>
        </fieldset>
    </form>
</div>
<div class="main">
    <img alt="@Html.AttributeEncode(photo.FileTitle)" src="@Href("~/Photo/Thumbnail", photo.Id, New With {.size = "large"})" />
</div>