﻿@Code
   ' Cache the image for a minute
	Response.OutputCache(60)

	Dim photoId = UrlData(0).AsInt()
	Dim db = Database.Open("PhotoGallery")
	Dim photo = db.QuerySingle("SELECT * FROM Photos WHERE Id = @0", photoId)
	If photo Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	Dim size = If(Request("size"), "")

	Dim width = 0
	Dim height = 0
	Select Case size.ToUpperInvariant()
		Case "", "SMALL"
			width = 200
			height = 200
		Case "MEDIUM"
			width = 400
			height = 300
		Case "LARGE"
			width = 625
			height = 625
		Case Else
			Response.SetStatus(HttpStatusCode.BadRequest)
			Return
	End Select

    Dim image = New WebImage(New MemoryStream(CType(photo.FileContents, System.Byte())))
	image.Resize(width, height).Write()
End Code