﻿@Code
    ' Cache the image for a minute
	Response.OutputCache(60)

	Dim tagName = UrlData(0)

	Dim db = Database.Open("PhotoGallery")
	Dim tag = db.Query("SELECT TagName FROM Tags WHERE TagName = @0", tagName)
    Dim photoList = db.Query("SELECT TOP(3) Photos.FileContents " &
                             " FROM Photos, Photos_Tags " &
                             " WHERE Photos.Id = Photos_Tags.Photos_Id AND Photos_Tags.Tags_TagName = @0", tagName).Shuffle().ToList()

	If tag IsNot Nothing AndAlso photoList.Count > 0 Then
		Using generator As New MultiThumbnailGenerator
			For Each photo In photoList
                Using imageStream = New System.IO.MemoryStream(CType(photo.FileContents, Byte()))
                    Using image = System.Drawing.Image.FromStream(imageStream)
                        generator.AddImage(image)
                    End Using
                End Using
			Next photo

			Using outStream = New System.IO.MemoryStream
				generator.WritePngToStream(outStream)
				Dim image = New WebImage(outStream)
				image.Write()
			End Using
		End Using
	Else
		' no photos - hopefully user will never see this
		Response.Redirect("~/Shared/gallery-empty.png")
	End If
End Code