﻿@Code
    Dim tagName = UrlData(0)
    Page.Title = "View Tag - " & tagName

    Dim db = Database.Open("PhotoGallery")
    Dim photos = db.Query(
    "SELECT Photos.Id, Photos.FileTitle " &
    "FROM Photos, Photos_Tags " &
    "WHERE Photos.Id = Photos_Tags.Photos_Id AND Photos_Tags.Tags_TagName = @0", tagName).ToList()
    Dim similarTags = db.Query(
    "SELECT Tags_TagName AS TagName, COUNT(*) AS Count " &
    "FROM Photos_Tags WHERE Photos_Id IN (SELECT Photos_Id FROM Photos_Tags WHERE Tags_TagName = @0) AND Tags_TagName != @0 " &
    "GROUP BY Tags_TagName " &
    "ORDER BY Count DESC", tagName).ToList()
End Code
<h1>@tagName</h1>
@If photos.Count = 0 Then
    @<p>
        There are no photos with this tag.</p>
Else
    If photos.Count = 1 Then
    @<p>
        There is one photo with this tag.</p>
    Else
    @<p>
        There are @photos.Count photos with this tag.</p>
    End If

    @<ul class="thumbnails">
        @For Each photo In photos
            @<li><a href="@Href("~/Photo/View", photo.Id)">
                <img alt="thumbnail of @Path.GetFileNameWithoutExtension(photo.FileTitle)" src="@Href("~/Photo/Thumbnail", photo.Id)" class="thumbnail-border" />
                <span class="image-overlay">@Path.GetFileNameWithoutExtension(photo.FileTitle)</span>
            </a></li>
    Next photo
    </ul>

    If similarTags.Count > 0 Then
    @<h2 class="similar-tags">
        Similar tags:</h2>
    @<ul class="tags">
        @For Each t As Object In similarTags
            @<li class="tag"><a href="@Href("~/Tag/View", t.TagName)">@t.TagName</a></li>
        Next t
    </ul>
    End If
End If