﻿@Code
    Dim db = Database.Open("PhotoGallery")

	Dim id = UrlData(0).AsInt()
	Dim user = db.QuerySingle("SELECT UserId, DisplayName, Bio FROM UserProfiles WHERE UserId = @0", id)
	If user Is Nothing Then
		Response.SetStatus(HttpStatusCode.NotFound)
		Return
	End If

	Page.Title = "User - " & user.DisplayName

	Dim photos = db.Query("SELECT Id, FileTitle FROM Photos WHERE UserId = @0 ORDER BY FileTitle", id).ToList()
End Code

<div class="sidebar">
    <dl>
        <dt>Display name</dt>
        <dd>@user.DisplayName</dd>
        <dt>Bio</dt>
        <dd>
            @If user.Bio <> "" Then
                @<text>@user.Bio</text>
            Else
                @<text>This user has not created a biography.</text>
            End If
        </dd>
    </dl>
    @If WebSecurity.CurrentUserId = user.UserId Then
        @<p>
            You can <a href="@Href("~/User")">edit your profile</a> if you desire.
        </p>
    End If
</div>
<div class="main">
<h1>@(user.DisplayName)'s Photos</h1>
    @If photos.Count = 1 Then
        @<h2>This user has uploaded one photo.</h2>
    Else
        @<h2>This user has uploaded @photos.Count photos.</h2>
    End If

    <ul class="thumbnails user-photos">
        @For Each photo In photos 
            @<li>
                <a href="@Href("~/Photo/View", photo.Id)">
                    <img alt="thumbnail of @Path.GetFileNameWithoutExtension(photo.FileTitle)" src="@Href("~/Photo/Thumbnail", photo.Id)" class="thumbnail-border" />
                    <span class="image-overlay">@Path.GetFileNameWithoutExtension(photo.FileTitle)</span>
                </a>
            </li>
        Next Photo
    </ul>
</div>